LIST P=18F4620		
#include <P18F4620.INC>
errorlevel 2

CONFIG OSC = INTIO7 ;  
CONFIG FCMEN = ON
CONFIG PWRT = ON
CONFIG WDT = OFF
CONFIG MCLRE = OFF
CONFIG LVP = OFF
CONFIG XINST = OFF
CONFIG DEBUG = OFF
CONFIG STVREN = ON
CONFIG CP0 = OFF
CONFIG CP1 = OFF
CONFIG CP2 = OFF
CONFIG CP3 = OFF


#define FOSC .32000000 ;32 
#define CLOCK .100000  ;100 
#define VALUE ((FOSC/CLOCK)/.4)-.1 ; SSPADD  I2C 100  


#define TIC48_Address 0x78
#define LCDData 0x40
#define Command 0x00
#define OneByte 0x80

udata_acs
Counter res 1

org 0x00
goto MAIN

MAIN:
movlw 0x70 ;    8  
movwf OSCCON,0
movlw 0x40 ;   8*4 = 32 
movwf OSCTUNE,0
clrf LATA,0
clrf LATB,0
clrf LATC,0
clrf LATD,0
clrf LATE,0
movlw 0x18
movwf TRISC,0

movlw 0x0F
movwf ADCON1,0

bra $
;  MSSP I2C
movlw VALUE
movwf SSPADD,0
movlw 0x80 ;Slew rate disabled
movwf SSPSTAT,0
movlw 0x08 ;I2C Master
movwf SSPCON1,0
bsf SSPCON1,SSPEN,0

movlw 0x80 ;   
movwf EECON1,0

;        
movlw upper INIT
movwf TBLPTRU,0
movlw high INIT
movwf TBLPTRH,0
movlw low INIT
movwf TBLPTRL,0

; 
bsf SSPCON2,SEN,0
btfsc SSPCON2,SEN,0
bra $-2

;  PCF8531
bcf PIR1,SSPIF,0
movlw TIC48_Address
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0

; 
movlw Command
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0

; 
movlw 0x0C ; 12 
movwf Counter,0
Init:
tblrd*+
movf TABLAT,W,0
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0
decfsz Counter,F,0
bra Init

; 
bsf SSPCON2,PEN,0
btfsc SSPCON2,PEN,0
bra $-2

; ,      RAM 
;    
rcall Clear ;256  (2 )
rcall Clear ; 256  (2 )

; 
bsf SSPCON2,SEN,0 ; Start I2C
btfsc SSPCON2,SEN,0
bra $-2

bcf PIR1,SSPIF,0
movlw TIC48_Address
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0

; 
movlw Command
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0

; 0  (Y)
movlw 0x40
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0

; 0  (X)
movlw 0x80
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0

; 
bsf SSPCON2,PEN,0 ; Stop I2C
btfsc SSPCON2,PEN,0
bra $-2


;       
;  
movlw upper G
movwf TBLPTRU,0
movlw high G
movwf TBLPTRH,0
movlw low G
movwf TBLPTRL,0

; 
bsf SSPCON2,SEN,0 ; Start I2C
btfsc SSPCON2,SEN,0
bra $-2

bcf PIR1,SSPIF,0
movlw TIC48_Address
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0

; 
movlw LCDData
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0

; 72   RAM PCF8531 (12   6 )
movlw .72
movwf Counter,0
text:
tblrd*+
movf TABLAT,W,0
movwf SSPBUF,0
btfss PIR1,SSPIF,0
bra $-2
bcf PIR1,SSPIF,0
decfsz Counter,F,0
bra text

; 
bsf SSPCON2,PEN,0 ; Stop I2C
btfsc SSPCON2,PEN,0
bra $-2

goto $

;         
Clear:  bsf SSPCON2,SEN,0 ; 
        btfsc SSPCON2,SEN,0
        bra $-2
        
        bcf PIR1,SSPIF,0
        movlw TIC48_Address
        movwf SSPBUF,0
        btfss PIR1,SSPIF,0
        bra $-2
        bcf PIR1,SSPIF,0
        
        ;; 
        movlw LCDData
        movwf SSPBUF,0
        btfss PIR1,SSPIF,0
        bra $-2
        bcf PIR1,SSPIF,0
        
        movlw 0x00
        movwf SSPBUF,0
        btfss PIR1,SSPIF,0
        bra $-2
        bcf PIR1,SSPIF,0
        movlw 0xFF
        movwf Counter,0
        clr:
        movlw 0x00
        movwf SSPBUF,0
        btfss PIR1,SSPIF,0
        bra $-2
        bcf PIR1,SSPIF,0
        decfsz Counter,F,0
        bra clr
        
        bsf SSPCON2,PEN,0 ; 
        btfsc SSPCON2,PEN,0
        bra $-2
        return

;--------------------------------------------------------------------------------
; PCF8531 (0xB5     Vlcd,  x2,  ,  4,5 )
INIT: db 0x20, 0x09, 0x0C, 0x05, 0x14, 0x01, 0x0A, 0x05, 0x08, 0x26, 0xB5, 0x01
;--------------------------------------------------------------------------------

G: db 0x3E, 0x41, 0x41, 0x49, 0x3A, 0x00
lA: db 0x7C, 0x12, 0x11, 0x12, 0x7C, 0x00
lN: db 0x7F, 0x02, 0x04, 0x08, 0x7F, 0x00
Y: db 0x01, 0x02, 0x7C, 0x02, 0x01, 0x00
Comma: db 0x00, 0x58, 0x38, 0x00, 0x00, 0x00
Spc: db 0x00, 0x00, 0x00, 0x00, 0x00, 0x00
H: db 0x7F, 0x08, 0x08, 0x08, 0x7F, 0x00
e: db 0x38, 0x54, 0x54, 0x54, 0x18, 0x00
ll: db 0x00, 0x41, 0x7F, 0x40, 0x00, 0x00
l: db 0x00, 0x41, 0x7F, 0x40, 0x00, 0x00
o: db 0x38, 0x44, 0x44, 0x44, 0x38, 0x00
Pling: db 0x00, 0x00, 0x5F, 0x00, 0x00, 0x00
end